<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS\Commands;
use CMSMS\CLI\App;
use CMSMS\CLI\GetOptExt\Command;
use CMSMS\CLI\GetOptExt\Option;
use CMSMS\CLI\GetOptExt\GetOpt;
use GetOpt\Operand;
use mams_user_query;
use mams_user_query_opt;

class GroupListCommand extends Command
{
    public function __construct( App $app )
    {
        parent::__construct( $app, 'mams-group-list' );
        $this->addOption( Option::Create('j','json')->setDescription('output data in JSON format'));
    }

    public function getShortDescription()
    {
        return 'List FEU groups';
    }

    public function getLongDescription()
    {
        return 'This command will return a list of FEU groups.';
    }

    public function handle()
    {
        $json = $this->getOption('json')->value();

        $mams = \cms_utils::get_module(MOD_MAMS);
        $list = $mams->GetGroupListFull();
        if( empty($list)) return;

        $tmp = null;
        foreach( $list as $row ) {
            $row['id'] = (int) $row['id'];
            $row['count'] = (int) $row['count'];
            $tmp[] = $row;
        }
        $list = $tmp;

        if( $json ) {
            echo json_encode( $list, JSON_PRETTY_PRINT );
            return;
        }

        $fmt = "%-4s %-40s %-4s %-s\n";
        printf($fmt,'id','name','count','description');
        printf($fmt,'--','----','----','----');
        foreach( $list as $rec ) {
            printf($fmt,$rec['id'],$rec['groupname'],$rec['count'],$rec['groupdesc']);
        }
    }
} // end of class.
